
#ifndef PLS_DATAFLOW_INPUT_H_
#define PLS_DATAFLOW_INPUT_H_

#include "pls/dataflow/internal/input.h"

namespace pls {
namespace dataflow {

template<int P, typename T>
class input {
  template<int OP, typename OT>
  friend
  class output;

  using internal_type = internal::input<P, T>;
  internal_type &internal_input_;

 public:
  explicit input(internal_type &internal_input) : internal_input_{internal_input} {};
};

}
}

#endif //PLS_DATAFLOW_INPUT_H_
