
#ifndef PLS_DATAFLOW_OUTPUT_H_
#define PLS_DATAFLOW_OUTPUT_H_

#include "input.h"

#include "pls/dataflow/internal/output.h"

namespace pls {
namespace dataflow {

template<int P, typename T>
class output {
  using internal_type = internal::output<P, T>;
  internal_type &internal_output_;

 public:
  explicit output(internal_type &internal_output) : internal_output_{internal_output} {};

  void operator>>(const input<P, T> &input) {
    internal_output_.connect(input.internal_input_);
  }
};

}
}

#endif //PLS_DATAFLOW_OUTPUT_H_
